#include <avr/delay.h>   
int AC_pin = 10, delay_zero=0;  // выход для симистора   
volatile uint16_t dim;      
int dimmer=255;// уровень димирования (0-255)  0 = max, 255 = min 

void setup()     
{      
  Serial.begin(9600);
  pinMode(AC_pin, OUTPUT);            
  attachInterrupt(0, zero_crosss_int, RISING); 
  }     

void zero_crosss_int()  // function to be fired at the zero crossing to dim the light
{
   delayMicroseconds(dim+1200);  // отсекаем лишнее  
   digitalWrite(AC_pin, HIGH);  // включить симистор     
   delayMicroseconds(40);      // короткая пауза, чтобы обеспечить включение симистора
   digitalWrite(AC_pin, LOW);   // выключение симистора(он выключится когда полупериод достигнет нуля)       
}    

void loop()     
{       
  // check if data has been sent from the computer:
  if (Serial.available()>0) {
    // read the most recent byte (which will be from 0 to 255):
    dimmer = Serial.parseInt();
    if(dimmer==255)
    for(int i=dim/33;i<=255;i++)
    {
      dim=33*i;
      delay(50);
      Serial.println(i);
    }
    
    if(dimmer==0)
    for(int i=dim/33;i>=0;i--)
    {
      dim=33*i;
      delay(50);
      Serial.println(i);
    }
    dim=33*dimmer;
    Serial.println(dimmer);
  }
  //if(dimmer > 0) dimmer--; else dimmer=255;  // пример уменьшения яркости лампы  
    
  //Serial.println(dimmer);
  //dim=(analogRead(A0)*255/1023); 
  delay(50); 
  
}  
